package edu.sc.seis.cormorant;

import sun.misc.Signal;
import sun.misc.SignalHandler;


/**
 * @author crotwell
 * Created on Jan 12, 2005
 */
public class DaemonSignalHandler implements SignalHandler {

    private SignalHandler oldHandler;

    // Static method to install the signal handler
    public static DaemonSignalHandler install(String signalName, Runnable runnable) {
        Signal diagSignal = new Signal(signalName);
        DaemonSignalHandler diagHandler = new DaemonSignalHandler();
        diagHandler.runnable = runnable;
        diagHandler.oldHandler = Signal.handle(diagSignal, diagHandler);
        return diagHandler;
    }
    Runnable runnable;
    
    // Signal handler method
    public void handle(Signal sig) {
        logger.debug("Signal handler called for signal " + sig);
        try {
            runnable.run();
            // Chain back to previous handler, if one exists
            // but don't send HUP as it causes the jvm to exit, but HUP ususally is only
            // for re-reading config and restarting
            if(oldHandler != SIG_DFL && oldHandler != SIG_IGN && ! sig.getName().equals("HUP")) {
                oldHandler.handle(sig);
            }
        } catch(Exception e) {
            logger.error("Signal handler failed: "+sig.getName(), e);
        }
    }
    private static final org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(DaemonSignalHandler.class);
}
